var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "react", "./Context.ts", "./createStore.ts"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var react_1 = __importStar(require("react"));
    var Context_ts_1 = __importDefault(require("./Context.ts"));
    var createStore_ts_1 = __importDefault(require("./createStore.ts"));
    exports.substores = new Map();
    var storeDispatchCovers = new WeakMap();
    var Provider = function (_a) {
        var store = _a.store, name = _a.name, middlewares = _a.middlewares, reducer = _a.reducer, preloadedState = _a.preloadedState, _b = _a.dispatchBubbles, dispatchBubbles = _b === void 0 ? true : _b, children = _a.children;
        var value = react_1.useMemo(function () {
            // 当前模块卸载时, store不会重新创建, 从map缓存中取, 防止数据丢失
            var currentSubStore = exports.substores.get(name);
            if (!currentSubStore) {
                var substore = createStore_ts_1.default(reducer, preloadedState, middlewares);
                exports.substores.set(name, substore);
                currentSubStore = substore;
            }
            var dispatch = currentSubStore.dispatch.bind(currentSubStore);
            // 防止当前模块内部store dispatch多次赋值, 避免多次调用父级的dispatch方法
            var hasCover = storeDispatchCovers.get(currentSubStore);
            if (!hasCover) {
                currentSubStore.dispatch = function (action) {
                    storeDispatchCovers.set(currentSubStore, true);
                    dispatch(action);
                    if (dispatchBubbles) {
                        store.dispatch(action);
                    }
                    return action;
                };
            }
            return {
                name: name,
                store: currentSubStore,
                parentStore: store,
            };
        }, [store, reducer, preloadedState]);
        return (react_1.default.createElement(Context_ts_1.default.Provider, { value: value }, children));
    };
    exports.default = Provider;
});
//# sourceMappingURL=Provider.js.map