var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "react", "hoist-non-react-statics", "./Context.ts", "./Provider.tsx"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var react_1 = __importStar(require("react"));
    var hoist_non_react_statics_1 = __importDefault(require("hoist-non-react-statics"));
    var Context_ts_1 = __importDefault(require("./Context.ts"));
    var Provider_tsx_1 = require("./Provider.tsx");
    var initStateUpdates = function () { return [null, 0]; };
    var storeStateUpdatesReducer = function (state, action) {
        var updateCount = state[1];
        return [action.payload, updateCount + 1];
    };
    var defaultMapDispatchToProps = function (dispatch) { return ({ dispatch: dispatch }); };
    var defaultMapStateToProps = function () { return ({}); };
    function connect(mapStateToProps, mapDispatchToProps) {
        var shouldHandleStateChanges = Boolean(mapStateToProps);
        if (!mapStateToProps) {
            mapStateToProps = defaultMapStateToProps;
        }
        if (!mapDispatchToProps) {
            mapDispatchToProps = defaultMapDispatchToProps;
        }
        return function WrappedWithConnect(WrappedComponent) {
            var wrappedComponentName = WrappedComponent.displayName
                || WrappedComponent.name || 'Component';
            var displayName = "connect" + wrappedComponentName;
            var Connect = function (props) {
                var _a;
                var _b = react_1.useContext(Context_ts_1.default), store = _b.store, name = _b.name, parentStore = _b.parentStore;
                var state = __assign(__assign({}, parentStore.getState()), store.getState());
                var stateProps = mapStateToProps(state, props);
                var dispatchProps = mapDispatchToProps((_a = store) === null || _a === void 0 ? void 0 : _a.dispatch, props);
                // 分发dispatch时, 强制更新子组件
                var _c = react_1.useReducer(storeStateUpdatesReducer, null, initStateUpdates), forceComponentUpdateDispatch = _c[1];
                react_1.useEffect(function () {
                    var _a;
                    if (!shouldHandleStateChanges)
                        return;
                    var forceUpdateFn = function () {
                        if (Provider_tsx_1.substores.get(name) !== store)
                            return;
                        forceComponentUpdateDispatch({
                            type: '@@redux/STORE_UPDATED',
                        });
                    };
                    var unsubscribe = (_a = store) === null || _a === void 0 ? void 0 : _a.subscribe(forceUpdateFn);
                    return function () {
                        unsubscribe();
                    };
                }, [store, parentStore]);
                return (react_1.default.createElement(WrappedComponent, __assign({}, props, stateProps, dispatchProps)));
            };
            Connect.WrappedComponent = WrappedComponent;
            Connect.displayName = displayName;
            return hoist_non_react_statics_1.default(Connect, WrappedComponent);
        };
    }
    exports.default = connect;
});
//# sourceMappingURL=connect.js.map